# Example for loading a state file.

import exceptions
from paraview import servermanager

# TODO: Set the path to the loadState.pvsm file
filename = "VisExamples/loadState.pvsm"

try:
  fp = open(filename, "r")
  fp.close()
except:
  raise exceptions.RuntimeError, \
    "Please set the filename to point to 'loadState.pvsm'"

# We create a server connection only if one isn't already present.
if not servermanager.ActiveConnection:
  servermanager.Connect()

# Load the state file.
servermanager.LoadState(filename)

# Obtain the first render view (for multiple view use GetRenderViews())
view = servermanager.GetRenderView()
view.StillRender()
raw_input("Hit 'Enter' to continue: ")

# ProxyManager is use to access objects created by loading the state file.
pxm = servermanager.ProxyManager()

# Print the list of available sources/filters loaded from the state.
sources_map = pxm.GetProxiesInGroup("sources")
for proxy_name in sources_map.keys():
  print proxy_name

# Now we want to change the PhiResolution for the Sphere1
print "Changing Phi and Theta resolution of the sphere to 20."
sphere1 = pxm.GetProxy("sources", "Sphere1")
sphere1.PhiResolution = 20
sphere1.ThetaResolution = 20

view.StillRender()

raw_input("Hit 'Enter' to continue: ")

# The state file has a animation set up. To play the animation locate the
# animation scene and then simply call Play() on it.
animation_map = pxm.GetProxiesInGroup("animation")
animation_scene = None
for proxy in animation_map.values():
  if proxy.GetXMLName() == "AnimationScene":
    animation_scene = proxy
if animation_scene:
  animation_scene.Play()
raw_input("Hit 'Enter' to continue: ")

